/*
  Stopwatch: tools for instrumentation of code to measure running time

  MAT 4880
  Bill Slough
 */

#include <sys/resource.h>
#include "stopwatch.h"

static struct rusage start;
static struct rusage stop;

/* start a timer */
void startWatch(void) {
    getrusage(RUSAGE_SELF, &start);  /* initial observation */
}

/* number of milliseconds since timer was started */
double elapsedTime(void) {
    double time;
    getrusage(RUSAGE_SELF, &stop);
    
    /* seconds to milliseconds, user + system */
    time =  (stop.ru_utime.tv_sec - start.ru_utime.tv_sec) * 1000.0f;
    time += (stop.ru_stime.tv_sec - start.ru_stime.tv_sec) * 1000.0f;

    /* microseconds to milliseconds, user + system */
    time += (stop.ru_utime.tv_usec - start.ru_utime.tv_usec) / 1000.0f;
    time += (stop.ru_stime.tv_usec - start.ru_stime.tv_usec) / 1000.0f;

    return time;
}
